/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.prj1.jsf;

import com.mycompany.prj1.beans.Project;
import com.mycompany.prj1.ejb.ProjectDaoBean;
import java.util.ArrayList;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.enterprise.context.RequestScoped;
import javax.inject.Named;
import org.apache.log4j.Logger;

/**
 *
 * @author thierry
 */
@Named
@RequestScoped
public class ProjectControllerV2 {

    private static final Logger logger = Logger.getLogger(ProjectControllerV2.class);

    private Project project;

    private List<Project> projects;

    public ProjectControllerV2() {
        logger.info("In ProjectController");

    }

    @PostConstruct
    public void postConstruct() {
        project = new Project();
        logger.info("In ProjectController postConstruct");
    }

    @EJB
    private ProjectDaoBean projectDaoBean;

    public String saveProject() {
        String returnValue = "display_project";
        logger.info("Sauvegarde du projet : " + project.
                toString());
        try {
            projectDaoBean.insertProject(project);
        } catch (Exception e) {
            e.printStackTrace();
            returnValue = "error_saving";
            return returnValue;
        }
        returnValue = getAllProjects();
        logger.info("returnValue : " + returnValue);
        return returnValue;
    }

    public String getAllProjects() {
        String returnValue = "display_projects";
        try {
            projects = projectDaoBean.getAllProjects();
            if (projects != null) {
                logger.info("Taille de projects=" + projects.size());
            } else {
                logger.info("Taille de projects=0");
            }
        } catch (Exception e) {
            e.printStackTrace();
            returnValue = "error_saving";
        }
        return returnValue;
    }

    public List<Project> getProjects() {
        return projects;
    }

    public void setProjects(List<Project> projects) {
        this.projects = projects;
    }

    public Project getProject() {
        return project;
    }

    public void setProject(Project project) {
        this.project = project;
        projects = new ArrayList<>();
    }

}
